#
# The Poll Tag
#
# (C) Copyright 2000 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
# All Rights Reserved
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>

__version__='$Revision: 0.0 $'[11:-2]

from DocumentTemplate.DT_String import String
from DocumentTemplate.DT_Util import *
from AccessControl.Role import RoleManager
import string, random, Globals, os, sys
from App.FindHomes import SOFTWARE_HOME
import cgi
import time
import Acquisition
import OFS
import cPickle

# filename = os.path.join(SOFTWARE_HOME, 'Products/Zippy/yow.lines')
##	def __init__(self, args, fmt='s'):
##		# if args[:5]=='poll ': args=args[5:]
##		# args=parse_params(args,cmd='',name='',expr='',fmt='s')
##		# self.args=args
##		# name,expr = name_param(args,'poll',1)
##		# self.__name__, self.expr = name,expr
##		# self.fmt=fmt
	
##		if len(args)==1 and fmt=='s':
##			if expr is None: expr=name
##			else: expr=expr.eval
##			self.simple_form=expr,

##		has_key=args.has_key	
##		if has_key('cmd'): 
##			command=args['cmd']
##		else:
##			command='current'

##		self.command=command
##		self.args=args

class PollTag:
	"""
	Polling Product
	"""

	# this is the minimal amount of meta-data needed by a DTML Tag.
	name='poll'
	expr = None
	action= ''
	command= ''
	args=[]

	def __init__(self, args):
		pass

	def findPollManagement(self, root):
		while root is not None:
			if hasattr(root, 'objectValues'):
				for o in root.objectValues():
					try:
						if ( hasattr(o, 'meta_type') and
							 o.meta_type=='Poll Administration'):
							return o
					except:
						pass
			if hasattr(root, 'aq_parent'):
				root=root.aq_parent
			else:
				root=None
		return None

	def render(self, md):
		us=md.this

		_PollManager=self.findPollManagement(us)
		if not _PollManager:
			print "Couldn't find a Poll Manaqer"
			return ''
		foob=_PollManager.index_html(us.REQUEST)
		foobr=render(us, foob)
		return foobr

	__call__=render


String.commands["poll"] = PollTag


    

